import os
import json
import gmpy2
from fractions import Fraction
from Crypto.Cipher import AES
from Crypto.Util.Padding import pad

def encrypt(n):
	IV = os.urandom(16)
	FLAG = open("flag.txt", "rb").read()

	k = int.to_bytes(n, 32, "big")
	aes = AES.new(k, AES.MODE_CBC, iv = IV)
	ctxt = aes.encrypt(pad(FLAG, 16))
	output = {
		"iv": IV.hex(),
		"ciphertext": ctxt.hex(),
	}
	return output

if __name__ == "__main__":
	a = Fraction(input(">>> a = "))
#	b = Fraction(input(">>> b = "))
	b = Fraction(2*3*3413, a)
	
	C = a ** 2 + b ** 2
	print(f"a  = {a}")
	print(f"b  = {b}")
	print(f"a * b  = {a * b} {type(a * b)}")
	print(f"a2  = {a**2}")
	print(f"b2  = {b**2}")
	print(f"C  = {C}")
	print(f"C/ = {C.numerator}")
	print(f"/C = {C.denominator}")
	print(f"C2 = {gmpy2.is_square(C.numerator)}")
	print(f"/C2= {gmpy2.is_square(C.denominator)}")
	
	if not a * b == 20478:
		print(f"{a} * {b} ne vaut pas 20478")
		exit(4)
	if not gmpy2.is_square(C.numerator):
		print(f"{C.numerator} n'est pas un carré")
		exit(2)
	if not gmpy2.is_square(C.denominator):
		print(f"{C.denominator} n'est pas un carré")
		exit(3)
	
	# Comme a*b==20478
	# Alors b = 20478 / a, il est fixé
	# c = a**2 + b**2 = a**2 + 20478**2 / a**2
	# c = (a**4 + 20478**2) / a**2
	# On va poser la condition: a entier
	# le dénominateur de c est alors un carré
	# ... mais je ne vois pas de solution à
	# a**4 + 20478**2 is a square
	# Huh?!

	print("Réussi!!")
	exit(0)
	
	# isqrt: ca serait pas les racines complexes?!
	# ah ben non: integer square root
	n = int(gmpy2.isqrt(C.numerator))
	
	output = encrypt(n)
	print(json.dumps(output))

